import { Node } from '@babel/types';
/**
 * 解析代码并提取结构化语句信息
 * @param code 原始代码字符串
 * @param ast 经过转换的AST语法树
 * @returns 包含语句集合和错误信息的对象
 */
export declare const statementParser: (code: string, ast: Node) => {
    readonly statements: any[];
    readonly errorsByStatements: Record<string, string>;
};
/**
 * 将原始代码转换为结构化语句信息
 * @param code 需要解析的代码字符串
 * @returns 包含语句集合和错误信息的对象
 */
export declare const parseCodeStatements: (code: string, imports?: string) => {
    readonly statements: any[];
    readonly errorsByStatements: Record<string, string>;
};
